// ====================== Color LCD  α׷ ==============================
//  : 320*240 TFT LCD(T32QT7690-HX8347)
// -----------------------------------------------------------------------------
// ȭ ǥ 
#define		_SCREEN_COLUMN_SET	0			// ι ǥø ʻ(0,0) 
#define		_SCREEN_ROW_SET		1			// ι ǥø ʻ(0,0) 

#define		_SCREEN_COLUMN_X	319			// ι ǥø X ִ밪
#define		_SCREEN_COLUMN_Y	239			// ι ǥø Y ִ밪
#define		_SCREEN_ROW_X		239			// ι ǥø X ִ밪
#define		_SCREEN_ROW_Y		319			// ι ǥø Y ִ밪

// Լ 
void Cleardevice(void);						// ü ȭ 
void ScreenSet(int mode,int x1,int y1,int x2,int y2);		// ǥ ȭ 
void Image_Disp_8bit(int mode,int x, int y, int x_size,int y_size,unsigned char flash *image);// 8Bit ̹  ǥ(κ ǥ)
void Image_Screen_Disp_8bit(int mode,int x, int y, int x_size,int y_size,unsigned char flash *image1,unsigned char flash *image2,unsigned char flash *image3);// 8Bit ̹  ǥ(ū  ǥ)

void Image_Disp_16bit(int mode,int x, int y, int x_size,int y_size,unsigned char flash *image);// 16Bit ̹  ǥ(κ ǥ)
void Image_Screen_Disp_16bit(int mode,int x, int y, int x_size,int y_size,unsigned char flash *image1,unsigned char flash *image2,unsigned char flash *image3,
                             unsigned char flash *image4,unsigned char flash *image5);// 16Bit ̹  ǥ(ū  ǥ)

// LCD H/W 
void Clcd_Init(void);						// Golor LCD Init
void CLCD_Command_Data(int regnum,unsigned datau);		// شּҿ Register NO.+Data Write
void CLCD_Command(int regnum);					// CLCD Command Register NO. write
void CLCD_Cdata(unsigned datau);				// CLCD Command Register Data write
unsigned CLCD_GRAM_dread(void);					// CLCD GRAM Data read
void lcd_delay(unsigned short time);				// LCD ð Լ time*1ms

//  
int _screen_mode = _SCREEN_COLUMN_SET;				// ȭ ǥù 
int _screen_xmax = _SCREEN_COLUMN_X;				// θ ִ밪
int _screen_ymax = _SCREEN_COLUMN_Y;				// θ ִ밪

int _screen_curx = 0;						// X ǥ 
int _screen_cury = 0;						// Yǥ 

// ================== 8bit ̹  ǥ(Ϻ ) =======================
// [μ] int mode,int x,int y,int x_size,int y_size,unsigned char flash *image
// Item1: ȭ   :: _SCREEN_COLUMN_SET( ȭ), _SCREEN_ROW_SET( ȭ)
// Item2:  xǥ : θ ǥý(0-319) / θ ǥý(0-239)
// Item3:  yǥ : θ ǥý(0-239) / θ ǥý(0-319)
// Item4: x ̹ ũ
// Item5: y ̹ ũ
// Item6: ǥ ̹ (32000Byte ̳)
// []  ȭ(0,0,319,239)
//         ȭ(0,0,239,319)
//        BGR(233) : BBGGGRRR ( )
//        BGR(323) : BBBGGRRR
//        BGR(332) : BBBGGGRR
// -----------------------------------------------------------------------------
void Image_Disp_8bit(int mode,int x, int y, int x_size,int y_size,unsigned char flash *image)
{
unsigned char uc,pa,pc;
unsigned i,total_size;

	ScreenSet(mode,x,y,x+(x_size-1),y+(y_size-1));		// ǥȭ(/) 
	total_size = x_size * y_size;				// ü ǥ  

	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1

	for(i = 0; i < total_size; i++){			// ü ǥ  
		uc = *image++;					// Data Read
		if(uc == 0xff) pa = pc = 0xff;
		else{
// BGR(233) BBGGGRRR
			pc = (uc & 0x07) << 5;			// red   3bit
			pc |= (uc & 0x38) >> 3;			// green 3bit
			pa = (uc & 0xc0) >> 3;			// blue  2bit
// BGR(323) BBBGGRRR
//			pc = (uc & 0x07) << 5;			// red   3bit
//			pc |= (uc & 0x18) >> 2;			// green 2bit
//			pa = (uc & 0xe0) >> 3;			// blue  3bit
// BGR(332) BBBGGGRR
//			pc = (uc & 0x03) << 6;			// red   2bit
//			pc |= (uc & 0x1c) >> 2;			// green 3bit
//			pa = (uc & 0xe0) >> 3;			// blue  3bit
		}
		PORTA = pa;					// d[0..7]
		PORTC = pc;					// d[8..15]

		PORTG &= ~0x01;					// PORTG.0 :: CLCD_WR\ = 0
		PORTG |= 0x01;					// PORTG.0 :: CLCD_WR\ = 1
	}
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
}

// ============ 8bit ̹  ǥ(ȭ ü Ǵ ū ȭ) ===============
// [μ] int mode,int x,int y,int x_size,int y_size,unsigned char flash *image1,unsigned char flash *image2,unsigned char flash *image3
// Item1: ȭ   :: _SCREEN_COLUMN_SET( ȭ), _SCREEN_ROW_SET( ȭ)
// Item2:  xǥ : θ ǥý(0-319) / θ ǥý(0-239)
// Item3:  yǥ : θ ǥý(0-239) / θ ǥý(0-319)
// Item4: x ̹ ũ
// Item5: y ̹ ũ
// Item6: ǥ ̹ 1(32000Byte ̳)
// Item7: ǥ ̹ 2(32000Byte ̳)
// Item8: ǥ ̹ 3(32000Byte ̳)
// []  ȭ(0,0,319,239)
//         ȭ(0,0,239,319)
//        BGR(233) : BBGGGRRR ( )
//        BGR(323) : BBBGGRRR
//        BGR(332) : BBBGGGRR
// -----------------------------------------------------------------------------
void Image_Screen_Disp_8bit(int mode,int x, int y, int x_size,int y_size,unsigned char flash *image1,unsigned char flash *image2,unsigned char flash *image3)
{
unsigned char uc,pa,pc;
unsigned char flash *image;
unsigned i,j,total_cnt = 0,total_size;
long total_sizel;

	ScreenSet(mode,x,y,x+(x_size-1),y+(y_size-1));		// ǥȭ(/) 
	total_sizel = (long)x_size * (long)y_size;		// ü ǥ  
	if(total_sizel >= 32000L){
		total_cnt = (unsigned)(total_sizel / 32000L);	// LOOP ī 
		i = (unsigned)(total_sizel % 32000L);		// ?
		if(i != 0) total_cnt++;
		total_size = 32000U;				//  			
	}
	else if(total_sizel > 0){				//  0 ũ
		total_size = (unsigned)total_sizel; 
		total_cnt = 1;
	}
	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1
	
	for(i = 0; i < total_cnt; i++){				// ü  ?
		if(i > 0){					// ù°  
			if(total_sizel >= 32000L){		// ǥ  
				total_size = 32000;
				total_sizel -= 32000L;
			}
			else total_size = (unsigned)total_sizel; 
		}
		switch(i){
			case 0: image = image1;			// ̹ 1
				break;
			case 1: image = image2;			// ̹ 2
				break;
			case 2: image = image3;			// ̹ 3
				break;
			default: break;
		}
		for(j = 0; j < total_size; j++){		// ü (64000Byte ̳)
			uc = *image++;				// Data Read
			if(uc == 0xff) pa = pc = 0xff;
			else{
// BGR(233) BBGGGRRR
				pc = (uc & 0x07) << 5;		// red   3bit
				pc |= (uc & 0x38) >> 3;		// green 3bit
				pa = (uc & 0xc0) >> 3;		// blue  2bit
// BGR(323) BBBGGRRR
//				pc = (uc & 0x07) << 5;		// red   3bit
//				pc |= (uc & 0x18) >> 2;		// green 2bit
//				pa = (uc & 0xe0) >> 3;		// blue  3bit
// BGR(332) BBBGGGRR
//				pc = (uc & 0x03) << 6;		// red   2bit
//				pc |= (uc & 0x1c) >> 2;		// green 3bit
//				pa = (uc & 0xe0) >> 3;		// blue  3bit
			}
			PORTA = pa;				// d[0..7]
			PORTC = pc;				// d[8..15]
	
			PORTG &= ~0x01;				// PORTG.0 :: CLCD_WR\ = 0
			PORTG |= 0x01;				// PORTG.0 :: CLCD_WR\ = 1
		}
	}
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
}

// ================== 16bit ̹  ǥ(Ϻ ) =======================
// [μ] int mode,int x,int y,int x_size,int y_size,unsigned char flash *image
// Item1: ȭ   :: _SCREEN_COLUMN_SET( ȭ), _SCREEN_ROW_SET( ȭ)
// Item2:  xǥ : θ ǥý(0-319) / θ ǥý(0-239)
// Item3:  yǥ : θ ǥý(0-239) / θ ǥý(0-319)
// Item4: x ̹ ũ
// Item5: y ̹ ũ
// Item6: ǥ ̹ (32000Byte ̳)
// []  ȭ(0,0,319,239)
//         ȭ(0,0,239,319)
//        RGB(565) : RRRRRGGGGGGBBBBB
// -----------------------------------------------------------------------------
void Image_Disp_16bit(int mode,int x, int y, int x_size,int y_size,unsigned char flash *image)
{
unsigned i,total_size;

	ScreenSet(mode,x,y,x+(x_size-1),y+(y_size-1));		// ǥȭ(/) 
	total_size = x_size * y_size;				// ü ǥ  

	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1

	for(i = 0; i < total_size; i++){			// ü ǥ  
		PORTC = *image++;				// Data Read D[8..15]
		PORTA = *image++;				// Data Read D[0..7]

		PORTG &= ~0x01;					// PORTG.0 :: CLCD_WR\ = 0
		PORTG |= 0x01;					// PORTG.0 :: CLCD_WR\ = 1
	}
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
}

// ============ 16bit ̹  ǥ(ȭ ü Ǵ ū ȭ) ===============
// [μ] int mode,int x,int y,int x_size,int y_size,unsigned char flash *image1,unsigned char flash *image2,unsigned char flash *image3
// Item1: ȭ   :: _SCREEN_COLUMN_SET( ȭ), _SCREEN_ROW_SET( ȭ)
// Item2:  xǥ : θ ǥý(0-319) / θ ǥý(0-239)
// Item3:  yǥ : θ ǥý(0-239) / θ ǥý(0-319)
// Item4: x ̹ ũ
// Item5: y ̹ ũ
// Item6: ǥ ̹ 1(32000Byte ̳)
// Item7: ǥ ̹ 2(32000Byte ̳)
// Item8: ǥ ̹ 3(32000Byte ̳)
// Item9: ǥ ̹ 4(32000Byte ̳)
// Item10:ǥ ̹ 5(32000Byte ̳)
// []  ȭ(0,0,319,239)
//        RGB(565) : RRRRRGGGGGGBBBBB
// -----------------------------------------------------------------------------
void Image_Screen_Disp_16bit(int mode,int x, int y, int x_size,int y_size,unsigned char  flash *image1,unsigned char  flash *image2,
			     unsigned char  flash *image3,unsigned char flash *image4,unsigned char flash *image5)
{
unsigned char flash *image;
unsigned i,j,total_cnt = 0,total_size;
long total_sizel;

	ScreenSet(mode,x,y,x+(x_size-1),y+(y_size-1));		// ǥȭ(/) 
	total_sizel = (long)x_size * (long)y_size;		// ü ǥ  
	if(total_sizel >= 32000L){
		total_cnt = (unsigned)(total_sizel / 32000L);	// LOOP ī 
		i = (unsigned)(total_sizel % 32000L);		// ?
		if(i != 0) total_cnt++;
		total_size = 32000U;				//  			
	}
	else if(total_sizel > 0){				//  0 ũ
		total_size = (unsigned)total_sizel; 
		total_cnt = 1;
	}
	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1
	
	for(i = 0; i < total_cnt; i++){				// ü  ?
		if(i > 0){					// ù°  
			if(total_sizel >= 32000L){		// ǥ  
				total_size = 32000;
				total_sizel -= 32000L;
			}
			else total_size = (unsigned)total_sizel; 
		}
		switch(i){
			case 0: image = image1;			// ̹ 1
				break;
			case 1: image = image2;			// ̹ 2
				break;
			case 2: image = image3;			// ̹ 3
				break;
			case 3: image = image4;			// ̹ 4
				break;
			case 4: image = image5;			// ̹ 5
				break;
			default: break;
		}
		for(j = 0; j < total_size; j++){		// ü (64000Byte ̳)
			PORTC = *image++;			// Data Read D[8..15]
			PORTA = *image++;			// Data Read D[0..7]
	
			PORTG &= ~0x01;				// PORTG.0 :: CLCD_WR\ = 0
			PORTG |= 0x01;				// PORTG.0 :: CLCD_WR\ = 1
		}
	}
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
}

// =============================== LCD ȭ  ===============================
// [μ] void
// []  ȭ(0,0,319,239)
//         ȭ(0,0,239,319)
// -----------------------------------------------------------------------------
void Cleardevice(void)
{
unsigned short i,j;

	if(_screen_mode == _SCREEN_COLUMN_SET) ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);// ǥȭ  
	else ScreenSet(_SCREEN_ROW_SET,0,0,_SCREEN_ROW_X,_SCREEN_ROW_Y);// ǥȭ  

	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1

	for(i = 0; i <= _screen_ymax; i++){
		PORTA = 0x00;					// BLACK
		PORTC = 0x00;
		for(j = 0; j <= _screen_xmax; j++){
			PORTG &= ~0x01;				// PORTG.0 :: CLCD_WR\ = 0
			PORTG |= 0x01;				// PORTG.0 :: CLCD_WR\ = 1
        	}
	}
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
	_screen_curx = _screen_cury = 0;
}

// =========================== ǥ ȭ  ==================================
// [μ] int mode,int x1,int y1, int x2, int y2
// Item1: ũ (_SCREEN_COLUMN_SET,_SCREEN_ROW_SET)
//        _SCREEN_COLUMN_SET : ȭ  ġ : ʻ(0,0,319,239)
//        _SCREEN_ROW_SET    : ȭ  ġ : ʻ(0,0,239,320)
// Item2:  xǥ : θ ǥý(0-319) / θ ǥý(0-239)
// Item3:  yǥ : θ ǥý(0-239) / θ ǥý(0-319)
// Item4:  xǥ   : θ ǥý(0-319) / θ ǥý(0-239)
// Item5:  yǥ   : θ ǥý(0-319) / θ ǥý(0-319)
// []  ȭ(0,0,319,239)
//         ȭ(0,0,239,319)
// -----------------------------------------------------------------------------
void ScreenSet(int mode,int x1,int y1,int x2,int y2)
{
	if(mode == _SCREEN_COLUMN_SET){
		CLCD_Command_Data(0x16,0x00a8);			// Memory Access Contro : MV=1, MX=0, MY=1, BGR=1 mode.
		_screen_mode = _SCREEN_COLUMN_SET;		// ȭ  ġ
		_screen_xmax = x2;				// θ ִ밪
		_screen_ymax = y2;				// θ ִ밪
	}
	else{
		CLCD_Command_Data(0x16,0x00c8);			// Memory Access Contro : MV=1, MX=1, MY=1, BGR=1 mode.
		_screen_mode = _SCREEN_ROW_SET;			// ȭ  ġ
		_screen_xmax = x2;				// θ ִ밪
		_screen_ymax = y2;				// θ ִ밪
	}
	CLCD_Command_Data(0x02,(x1>>8)&0xff);			// Column Address Start Register SC[8..15]
	CLCD_Command_Data(0x03,x1&0xff);			// Column Address Start Register SC[0..7]

	CLCD_Command_Data(0x06,(y1>>8)&0xff);			// Row Address Start Register SP[8..15]
	CLCD_Command_Data(0x07,y1&0xff);			// Row Address Start Register SP[0..7]

	CLCD_Command_Data(0x04,(x2>>8)&0xff);			// Column Address End Register EC[8..15]
	CLCD_Command_Data(0x05,x2&0xff);			// Column Address End Register EC[0..7]

	CLCD_Command_Data(0x08,(y2>>8)&0xff);			// Row Address End Register EP[8..15]
	CLCD_Command_Data(0x09,y2&0xff);			// Row Address End Register EP[0..7]
}

// ============================== TFT LCD ʱȭ ===============================
// [μ] void
// [] 320*240 TFT LCD :: 80System 16bit Bus
// -----------------------------------------------------------------------------
void Clcd_Init(void)
{
	lcd_delay(100);						// Power ON ð 
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
	PORTG |= 0x03;						// PORTG.0,1 :: CLCD_WR\ = RD\ = 1
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Instruction Set

	PORTA=0xff;						// PORTA OUTPUT = 0xff
	DDRA=0xff;                                              // PORTA(CLCD_D[0..7] = OUTPUT MODE)
	PORTC=0xff;						// PORTC OUTPUT = 0xff
	DDRC=0xff;                                              // PORTC(CLCD_D[8..15] = OUTPUT MODE)

// ׷ LCD 
	PORTE &= 0xbf;						// PORTE.6(RST\) = 0
	lcd_delay(100);						// reset ð 
	PORTE |= 0x40;						// PORTE.6(RST\) = 1
	lcd_delay(50);						// reset ð 
	
// init_lcd_registers
//Gamma setting 
 	CLCD_Command_Data(0x0046,0x0081);			// Gamma(1)
 	CLCD_Command_Data(0x0047,0x0010);			// Gamma(2)
 	CLCD_Command_Data(0x0048,0x0001);			// Gamma(3)
	CLCD_Command_Data(0x0049,0x0004);			// Gamma(4)
	CLCD_Command_Data(0x004A,0x0010);			// Gamma(5)
	CLCD_Command_Data(0x004B,0x0076);			// Gamma(6)
	CLCD_Command_Data(0x004C,0x0037);			// Gamma(7)
	CLCD_Command_Data(0x004D,0x0067);			// Gamma(8)
	CLCD_Command_Data(0x004E,0x0007);			// Gamma(9)
	CLCD_Command_Data(0x004F,0x0014);			// Gamma(10)
	CLCD_Command_Data(0x0050,0x000A);			// Gamma(11)
	CLCD_Command_Data(0x0051,0x000E);			// Gamma(12)

//Window Setting
   	CLCD_Command_Data(0x0002,0x0000);			// Column Address2
	CLCD_Command_Data(0x0003,0x0000);			// Column Address1
	CLCD_Command_Data(0x0004,0x0000);			// Column End2
	CLCD_Command_Data(0x0005,0x00EF);			// Column End1 :: 239
	CLCD_Command_Data(0x0006,0x0000);			// Row Address Start2
	CLCD_Command_Data(0x0007,0x0000);			// Row Address Start1
	CLCD_Command_Data(0x0008,0x0001);			// Row Address End2 :: 319
	CLCD_Command_Data(0x0009,0x003F);			// Row Address End1

//Display Setting
	lcd_delay(10);						// 10ms Delay
	CLCD_Command_Data(0x01,0x0006);				// Display Mode

	CLCD_Command_Data(0x16,0x00C8);				// Memory Access Control
	CLCD_Command_Data(0x23,0x0095);				// Cycle Control 1
	CLCD_Command_Data(0x24,0x0095);				// Cycle Control 2
	CLCD_Command_Data(0x25,0x00FF);				// Cycle Control 3
	CLCD_Command_Data(0x27,0x0002);				// Display Control 2
	CLCD_Command_Data(0x28,0x0002);				// Display Control 3
	CLCD_Command_Data(0x29,0x0002);				// Display Control 4
	CLCD_Command_Data(0x2A,0x0002);				// Display Control 5
	CLCD_Command_Data(0x2C,0x0002);				// Display Control 6
	CLCD_Command_Data(0x2D,0x0002);				// Display Control 7

	CLCD_Command_Data(0x003A,0x0001);			// Cycle Control 1
	CLCD_Command_Data(0x003B,0x0001);			// Cycle Control 2
	CLCD_Command_Data(0x003C,0x00F0);			// Cycle Control 3
	CLCD_Command_Data(0x003D,0x0000);			// Cycle Control 4
	lcd_delay(20);						// 20ms Delay
	CLCD_Command_Data(0x35,0x0038);				// Display Control 9
	CLCD_Command_Data(0x36,0x0078);				// Display Control 10
	CLCD_Command_Data(0x3E,0x0038);				// Cycle Control 5
	CLCD_Command_Data(0x40,0x000F);				// Cycle Control 6
	CLCD_Command_Data(0x41,0x00F0); 			// Cycle Control 7

	CLCD_Command_Data(0x38,0x0000);				// RGB Interface Control1

// Power Setting
 	CLCD_Command_Data(0x19,0x0049);				// OCS Control1
	CLCD_Command_Data(0x93,0x000A);				// DCCLK SYNC TO CL1
	lcd_delay(10);						// 10ms Delay
	CLCD_Command_Data(0x20,0x0050);				// Power Control 06
	CLCD_Command_Data(0x1D,0x0004);				// Power Control 03
	CLCD_Command_Data(0x1E,0x0001);				// Power Control 04

	CLCD_Command_Data(0x1F,0x0008);				// Power Control 05
	CLCD_Command_Data(0x44,0x0054); 			// VCOM Control2
//	CLCD_Command_Data(0x45,0x0010);				// VCom control3 :: original value for 3.0 Volts power supply
	CLCD_Command_Data(0x45,0x000e);				// VCom control3 :: by Brain for 3.3Volts power supply
	lcd_delay(10);						// 10ms Delay
	CLCD_Command_Data(0x1C,0x0004); 			// Power Control2
	lcd_delay(20);						// 20ms Delay
	CLCD_Command_Data(0x43,0x0080);				// VCOM Control1
	lcd_delay(5);						// 5ms Delay
	CLCD_Command_Data(0x1B,0x0008);				// Power Control1
	lcd_delay(40);						// 40ms Delay
	CLCD_Command_Data(0x1B,0x0010);				//  Power Control1
	lcd_delay(40);						// 40ms Delay

//Display On Setting
	CLCD_Command_Data(0x90,0x007F);				// Display Control8
	CLCD_Command_Data(0x26,0x0004);				// Display Control1
 	lcd_delay(40);						// 40ms Delay
	CLCD_Command_Data(0x26,0x0024);				// Display Control1
	CLCD_Command_Data(0x26,0x002C);				// Display Control1
 	lcd_delay(40);						// 40ms Delay
	CLCD_Command_Data(0x26,0x003C); 			// Display Control1
  	CLCD_Command_Data(0x57,0x0002);
	CLCD_Command_Data(0x55,0x0000);
	CLCD_Command_Data(0x57,0x0000);

	ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);//  ǥ ȭ 
}

// ======================= Command Register NO+Data write ====================
// [μ] int regnum,unsigned datau
// Item1: Register No.
// Item2:  
// ---------------------------------------------------------------------------
void CLCD_Command_Data(int regnum,unsigned datau)
{
	PORTG |= 0x03;						// PORTG.0,1 :: CLCD_WR\ = RD\ = 1
// regnum write
	PORTE &= ~0x20;						// PORTE.5 :: CLCD RS = 0 :: Instruction Set
	PORTE &= ~0x08;						// CLCD_164245_DIR = 0 :: WR Mode
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG &= ~0x01;						// PORTG.0 :: CLCD_WR\ = 0

	PORTC = 0;						// CLCD_D[8..15] = 0
	PORTA = regnum & 0xff;					// CLCD_D[0..7] = regnum
	
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1

// data 16bit write
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG &= ~0x01;						// PORTG.0 :: CLCD_WR\ = 0

	PORTC = (datau >> 8) & 0xff;				// PORTC = datau[8..15] high byte
	PORTA = datau & 0xff;					// PORTA = datau[0..7]  low  byte
	
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
}

// ======================== Command Register NO. write =======================
// [μ] int regnum,unsigned datau
// Item1: Register No.
// ---------------------------------------------------------------------------
void CLCD_Command(int regnum)
{
	PORTG |= 0x03;						// PORTG.0,1 :: CLCD_WR\ = RD\ = 1
// regnum write
	PORTE &= ~0x20;						// PORTE.5 :: CLCD RS = 0 :: Instruction Set
	PORTE &= ~0x08;						// CLCD_164245_DIR = 0 :: WR Mode
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG &= ~0x01;						// PORTG.0 :: CLCD_WR\ = 0

	PORTC = 0;						// CLCD_D[8..15] = 0
	PORTA = regnum & 0xff;					// CLCD_D[0..7] = regnum
	
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
}

// ======================= Command Register Data write =======================
// [μ] unsigned datau
// Item1:  
// ---------------------------------------------------------------------------
void CLCD_Cdata(unsigned datau)
{
	PORTG |= 0x03;						// PORTG.0,1 :: CLCD_WR\ = RD\ = 1
// data 16bit write
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTE &= ~0x08;						// CLCD_164245_DIR = 0 :: WR Mode
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG &= ~0x01;						// PORTG.0 :: CLCD_WR\ = 0

	PORTC = (datau >> 8) & 0xff;				// PORTC = datau[8..15] high byte
	PORTA = datau & 0xff;					// PORTA = datau[0..7]  low  byte
	
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
}

// ========================== Graphic RAM Data Read ==========================
// [μ] void
// []  ġ ȼ .
// ---------------------------------------------------------------------------
unsigned CLCD_GRAM_dread(void)
{
unsigned datau,datau1,datau2,datau3;

	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTA=0xff;						// PORTA Է PULL UP SET
	DDRA=0x00;                                              // PORTA(CLCD_D[0..7] = INPUT MODE)
	PORTC=0xff;						// PORTA Է PULL UP SET
	DDRC=0x00;                                              // PORTC(CLCD_D[8..15] = INPUT MODE)

	PORTE |= 0x28;						// PORTE.5 :: CLCD RS = 1 :: Data Set,CLCD_164245_DIR = 1 :: RD Mode
	PORTG |= 0x03;						// PORTG.0 :: CLCD_RD\ = 1,CLCD_WR\ = 1
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0

// dummy data read
	PORTG &= ~0x02;						// PORTG.1 :: CLCD_RD\ = 0
	PORTG |= 0x02;						// PORTG.1 :: CLCD_RD\ = 1
// data read R
	PORTG &= ~0x02;						// PORTG.1 :: CLCD_RD\ = 0
	datau1 = PINA & 0xff;					// CLCD_D[0..7]
	PORTG |= 0x02;						// PORTG.1 :: CLCD_RD\ = 1
// data read G
	PORTG &= ~0x02;						// PORTG.1 :: CLCD_RD\ = 0
	datau2 = PINA & 0xff;					// CLCD_D[0..7]
	PORTG |= 0x02;						// PORTG.1 :: CLCD_RD\ = 1
// data read B
	PORTG &= ~0x02;						// PORTG.1 :: CLCD_RD\ = 0
	datau3 = PINA & 0xff;					// CLCD_D[0..7]
	PORTG |= 0x02;						// PORTG.1 :: CLCD_RD\ = 1

	PORTE &= ~0x08;						// CLCD_164245_DIR = 0 :: WR Mode
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1

	PORTA=0xff;						// PORTA OUTPUT = 0xff
	DDRA=0xff;                                              // PORTC(CLCD_D[0..7] = OUTPUT MODE)
	PORTC=0xff;						// PORTC OUTPUT = 0xff
	DDRC=0xff;                                              // PORTC(CLCD_D[8..15] = OUTPUT MODE)
	
// RRRRR GGGGGG BBBBB
	datau = (datau1 << 8) & 0xf800;				// RED Data
	datau |= (datau2 << 3) & 0x07e0;			// GREEN Data
	datau |= (datau3 >> 3) & 0x001f;			// BLUE Data
	return(datau);
}

// ============================== LCD Delay xxxms ============================
// [μ] unsigned short time
// Item1: ð time * 1ms
// ---------------------------------------------------------------------------
void lcd_delay(unsigned short time)
{
unsigned short i,j;

  	for(i=0;i<time;i++){
 		for(j=0;j<800;j++) #asm ("nop")
	}
}

