// ========================= Atmega128 ÷ LCD ׽Ʈ α׷ ===============
//  CPU : ATmega128-16M - 320*240 2.4" ÷ LCD
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : AvrStudio 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#define	__STDIO_FDEVOPEN_COMPAT_12

// ⺻ 
// === AVR includes ===
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
//#include <float.h>
//#include <math.h>

#include "avr/io.h"
#include "avr/interrupt.h"
#include "avr/delay.h"
#include "avr/pgmspace.h"

//  
#include "cpusetup.inc"							// cpu  ͷƮ  ƾ
#include "tftlcd.inc"							// ׷ LCD
#include "touch.inc"							// ġ 

//  ̹  
//#include "sample1_8.txt"						// ̹  8bit  150*120
#include "sample2_8.txt"						// ̹  8bit  200*120
//#include "sample3_8.txt"						// ̹  16bit 200*150
	
//#include "sample1_16.txt"						// ̹  16bit 150*120
//#include "sample2_16.txt"						// ̹  16bit 200*120
//#include "sample3_16.txt"						// ̹  16bit 200*150

// Լ 
void main_menu_disp(void);						//  ޴ ǥ

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();							// cpu ʱȭ
	TSC2003_Setup();						// I2c ʱȭ TSC2003ʱȭ
	Clcd_Init();							// LCD ʱȭ
	Cleardevice();							// ȭ Ұ
	main_menu_disp();						//  ޴ ǥ

// 8Bit BGR(233) ̹ ǥ
//	Image_Disp_8bit(_SCREEN_COLUMN_SET,80,60,160,120,image_temp8_1);//  ̹  ǥ 32000Byte ̳(sample1_8.txt)
	Image_Disp_8bit(_SCREEN_COLUMN_SET,60,60,200,120,image_temp8_1);//  ̹  ǥ 32000Byte ̳(sample2_8.txt)
//	Image_Disp_8bit(_SCREEN_COLUMN_SET,60,45,200,150,image_temp8_1);//  ̹  ǥ 32000Byte ̳(sample3_8.txt)
//	Image_Screen_Disp_8bit(_SCREEN_COLUMN_SET,60,45,200,150,image_temp8_1,image_temp8_1,image_temp8_1);// ̹  ǥ 32000Byte ̻(sample3.txt)

//16Bit RG(565) ̹ ǥ
//	Image_Disp_16bit(_SCREEN_COLUMN_SET,80,60,160,120,image_temp16_1);// ̹  ǥ 32000Byte ̳(sample1_16.txt)
// sample1_16.txt
//	Image_Screen_Disp_16bit(_SCREEN_COLUMN_SET,80,60,160,120,image_temp16_1,image_temp16_2,image_temp16_1,image_temp16_1,image_temp16_1);// ̹  ǥ 32000Byte ̻
// sample2_16.txt
//	Image_Screen_Disp_16bit(_SCREEN_COLUMN_SET,60,60,200,120,image_temp16_1,image_temp16_2,image_temp16_1,image_temp16_1,image_temp16_1);// ̹  ǥ 32000Byte ̻
// sample3_16.txt
//	Image_Screen_Disp_16bit(_SCREEN_COLUMN_SET,60,45,200,150,image_temp16_1,image_temp16_2,image_temp16_1,image_temp16_1,image_temp16_1);// ̹  ǥ 32000Byte ̻

	while(1){
		if(com1_rx_eflg){					// COM1  ˻
			putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
		if(Touch_Data(2)){					// ġ  ˻ 20ms
			printf("touch > (x)%d : (y)%d\r\n",Touch_X,Touch_Y);
		}
	}
	return 0;
}

// ==================================  ޴ ǥ =========================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("%s","======== TFT LCD Test Main =========\n");
	printf("%s","- Color LCD Image Display          -\n");
	printf("%s","- touch screen press : x,y disp    -\n");
	printf("%s","------------------------------------\n");
}
